Description

Redmine tabs (in Settings or Administration for instance) are all loaded at once when the page is loaded. When changing tab, the

URL is not updated, hence it breaks navigation in some minor ways, which I find annoying on a daily basis.. :

if the user reloads the page he's sent back to the default tab, not the one he was viewing

previous/next buttons behave counterintuitively : only the default tab remains in the history, and once you leave a tab, you never

go back to it without having to re-click on the tab

The simplest solution to that is to use the History API introduced a couple years ago in most browsers, so that URL is updated

whenever a click on a new tab occurs. Basically it boils down to this: 

/* better handling of history in redmine tabs */

$(function() {

  $(".tabs a").on("click", function() {

    //only trigger history API if supported

    if ("replaceState" in window.history) {

      //replace current URL with the "href" attribute of the current link

      window.history.replaceState(null, document.title, this.href);

    }

  })

})

 Any opinion on that is welcome. If none I'll add it in the next few days, I think I'll integrate it directly in the showTab() function.

Associated revisions

Revision 11765 - 2013-05-02 18:09 - Jean-Baptiste Barth

Update URL when changing tab (#13900).

History

#1 - 2013-04-28 22:10 - Jean-Baptiste Barth

- Description updated

#2 - 2013-05-02 18:10 - Jean-Baptiste Barth

- Status changed from New to Resolved

- Target version set to 2.4.0

Done in r11765

#3 - 2013-05-04 04:38 - Mischa The Evil

Nice... Thanks.

#4 - 2013-05-04 09:25 - Jean-Philippe Lang

Excellent!

#5 - 2013-07-11 21:38 - Jean-Philippe Lang

- Status changed from Resolved to Closed
